package muyu.data.test.clinet.config;

import lombok.extern.log4j.Log4j2;
import muyu.data.test.clinet.config.runner.AccessConfigRunner;
import muyu.data.test.common.dataSoutce.DataSourceConfig;
import muyu.data.test.common.model.DataModel;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Import;

import java.sql.*;
import java.util.*;
import java.util.List;

/**
 * 规则引擎客户端配置类
 */
@Log4j2
@ComponentScan
@Import(value = AccessConfigRunner.class)
public class AccessConfig {
    public List<DataModel> getRabdomData(Long id, String tableName,Integer ruleLevel) {
        List<List<DataModel>> listList = new ArrayList<>();
        Connection connection = DataSourceConfig.getConnection(id);
        String sql = "select * from " + tableName;
        try {
            //获取原数据
            Statement statement = connection.createStatement();
            ResultSet resultSet = statement.executeQuery(sql);
            PreparedStatement pst = connection.prepareStatement("select * from " + tableName);
            log.info("元数据1:{}",resultSet);
//        ResultSet resultSet1 = pst.executeQuery();
            //元数据信息
            ResultSetMetaData metaData = pst.getMetaData();
            //元数据数量
            int columnCount = metaData.getColumnCount();
            while (resultSet.next()){
                List<DataModel> list = new ArrayList<>();
                for (int i = 1; i <= columnCount; i++) {
                    String columnName = metaData.getColumnName(i);
                    log.info("字段名:{}",columnName);
                    String tableName1 = metaData.getTableName(i);
                    log.info("表名:{}",tableName1);
                    String columnClassName = metaData.getColumnClassName(i);
                    log.info("java类型:{}",columnClassName);
                    String columnTypeName = metaData.getColumnTypeName(i);
                    log.info("原类型:{}",columnTypeName);
                    String catalogName = metaData.getCatalogName(i);
                    log.info("数据库名:{}",catalogName);
                    Object object = resultSet.getObject(i);
                    log.info("字段值:{}",object);
                    DataModel build = DataModel.builder()
                            .key(columnName)
                            .val(object)
                            .sourceType(columnTypeName)
                            .processType(columnClassName)
                            .processClass(Class.forName(columnClassName))
                            .build();
                    log.info("测试内容:{}",build);
                    list.add(build);
                }
                listList.add(list);
        }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }
        log.info("长度:{}",listList.size());
        log.info("列表:{}",listList);
        if (listList.size() == 0){
            return null;
        }
        for (List<DataModel> list : listList) {
            System.out.println(list);
        }
        Random random = new Random();
        int i = random.nextInt(listList.size());
        return listList.get(i);
    }

    public List<List<DataModel>> getColumn(Long id, String tableName, Integer ruleLevel) {
        List<List<DataModel>> listList = new ArrayList<>();
        Connection connection = DataSourceConfig.getConnection(id);
        String sql = "select * from " + tableName;
        try {
            //获取原数据
            Statement statement = connection.createStatement();
            ResultSet resultSet = statement.executeQuery(sql);
            PreparedStatement pst = connection.prepareStatement("select * from " + tableName);
            log.info("元数据1:{}",resultSet);
            //元数据信息
            ResultSetMetaData metaData = pst.getMetaData();
            //元数据数量
            int columnCount = metaData.getColumnCount();
            while (resultSet.next()){
                List<DataModel> list = new ArrayList<>();
                for (int i = 1; i <= columnCount; i++) {
                    String columnName = metaData.getColumnName(i);
                    String columnClassName = metaData.getColumnClassName(i);
                    String columnTypeName = metaData.getColumnTypeName(i);
                    Object object = resultSet.getObject(i);
                    DataModel build = DataModel.builder()
                            .key(columnName)
                            .val(object)
                            .sourceType(columnTypeName)
                            .processType(columnClassName)
                            .processClass(Class.forName(columnClassName))
                            .build();
//                    log.info("测试内容:{}",build);
                    list.add(build);
                }
                listList.add(list);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }
        return listList;
    }
    private Map<String, String> getColumnComments(DatabaseMetaData metaData, String typeName) {
        Map<String, String> columnComents = new HashMap<>();
        try (ResultSet colums = metaData.getColumns(null, null, typeName, null)) {
            while (colums.next()) {
                String columsName = colums.getString("COLUMN_NAME");
                String columsComment = colums.getString("REMARKS");
                columnComents.put(columsName, columsComment);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
        return columnComents;
    }


}
