package muyu.data.test.clinet.config.runner;

import com.muyu.common.core.domain.Result;
import com.muyu.system.domain.DataAccess;
import com.muyu.system.remote.RemoteSystemManageService;
import lombok.extern.log4j.Log4j2;
import muyu.data.test.common.dataSoutce.DataSourceConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.sql.Connection;
import java.util.HashMap;
import java.util.List;

/**
 * 初始化加载
 */
@Log4j2
@Component
@Configuration
public class AccessConfigRunner implements ApplicationRunner {
    @Autowired
    private RemoteSystemManageService remoteSystemManageService;

    @Override
    public void run(ApplicationArguments args) throws Exception {
        //远程调用
        Result<List<DataAccess>> lists = remoteSystemManageService.lists();
//        log.info("数据源调用状态：{}",lists);
        //判断非空
        if (lists.getData() == null || lists.getData().isEmpty()){
            log.error("数据为空");
            return;
        }
        //获取数据源集合
        List<DataAccess> listResultData = lists.getData();
//        log.info("远程调用：{}",listResultData);
        //存入map
        //创建map
        HashMap<Long, DataAccess> frimaryVoHashMap = new HashMap<>();
        //遍历循环存入map
        listResultData.forEach(res -> {
            frimaryVoHashMap.put(res.getId(),res);
        });
        //遍历添加到hashMap
        for (DataAccess listResultDatum : listResultData) {
            if (listResultDatum.getType().equals("MySql")){
                //记录线程池
                DataSourceConfig.index(listResultDatum);
            }
        }
    }





}
