package muyu.data.test.clinet.config.runner;

import com.muyu.common.core.domain.Result;
import com.muyu.edition.domain.Edition;
import com.muyu.edition.domain.RuleEngine;
import com.muyu.goods.edition.remote.EditionDataRemoteService;
import com.muyu.goods.edition.remote.RemoteDataManagerService;
import lombok.extern.log4j.Log4j2;
import muyu.data.test.common.dataSoutce.EditionSoutceConfig;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Log4j2
@Component
@Configuration
public class DataEditionConfigRunner implements ApplicationRunner , ApplicationContextAware {
    @Autowired
    private RemoteDataManagerService remoteDataManagerService;
    @Autowired
    private EditionDataRemoteService editionDataRemoteService;

    /**
     * 根据环境变量来决定是否执行
     * @param applicationContext the ApplicationContext object to be used by this object
     * @throws BeansException
     */
    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        System.out.println("1");
    }
    @Override
    public void run(ApplicationArguments args) throws Exception {
        //获取引擎
        Result<List<RuleEngine>> listResult = remoteDataManagerService.list();
//        log.info("获取引擎：{}",listResult);
        List<RuleEngine> listResultData = listResult.getData();
        //获取规则
        Result<List<Edition>> tableDataInfoResult = editionDataRemoteService.lists();
//        log.info("获取规则:{}",tableDataInfoResult);
        List<Edition> editionList = tableDataInfoResult.getData();
//        log.info("获取规则:{}",editionList);
        //处理获取的引擎和规则
        for (RuleEngine listResultDatum : listResultData) {
            List<Edition> editions = editionList.stream().filter(e -> e.getRuleId().equals(listResultDatum.getRuleId())).collect(Collectors.toList());
            EditionSoutceConfig.indexByte(editions);
            for (Edition edition : editionList.stream().filter(e -> e.getRuleId().equals(listResultDatum.getRuleId())).collect(Collectors.toList())) {
                EditionSoutceConfig.index(listResultDatum.getRuleId(),edition);
            }
        }
        Long ruleId = listResultData.get(0).getRuleId();
        Long id = editionList.get(0).getId();
//        HashMap<Long, Edition> editionHashMap = EditionSoutceConfig.get(ruleId);
//        log.info("查看第一批:{}",editionHashMap);

        HashMap<Long, Map<String, byte[]>> even = EditionSoutceConfig.even();
        Map<String, byte[]> aByte = EditionSoutceConfig.getByte(id);
        log.info("总表:{}",even);
        log.info("第一个:{}",aByte);
        String versionClass = editionList.get(0).getVersionClass();
        byte[] bytes = aByte.get(versionClass);
        String s = new String(bytes);
        log.info(s);

    }


}
