package muyu.data.test.common.dataSoutce;

import com.alibaba.druid.pool.DruidDataSource;
import com.muyu.edition.constant.RuleOperationConstants;
import com.muyu.edition.domain.Edition;
import com.muyu.edition.domain.RuleEngine;
import lombok.Data;
import lombok.extern.log4j.Log4j2;
import muyu.data.test.common.dymamicLoad.DynamicLoader;
import org.bouncycastle.pqc.crypto.newhope.NHSecretKeyProcessor;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Data
@Component
@Configuration
@Log4j2
public class EditionSoutceConfig {
    private static HashMap<Long, HashMap<Long, Edition>> hashMap = new HashMap<>();
    private static HashMap<Long, Map<String, byte[]>> longHashMapHashMap = new HashMap<>();

    public static void index(Long ruleId, Edition edition){
        HashMap<Long, Edition> editionHashMap = new HashMap<>();
        editionHashMap.put(edition.getId(),edition);
        hashMap.put(ruleId,editionHashMap);
    }

    public static void indexByte(List<Edition> list){
        list.stream().forEach(engine -> {
            //获取版本内容
            String content = engine.getRuleContent().replaceAll("\r\n", "");
            //编译生成class文件存放到Map中
            Map<String, byte[]> compile = DynamicLoader.compile( engine.getVersionClass() + RuleOperationConstants.FILE_SUFFIX, content);
            longHashMapHashMap.put(engine.getId(),compile);
        });
    }

    public static HashMap<Long,Edition> get(Long ruleId){
        return hashMap.get(ruleId);
    }

    public static Map<String,byte[]> getByte(Long id){
        return longHashMapHashMap.get(id);
    }

    public static HashMap<Long , Map<String, byte[]>> even(){
        return longHashMapHashMap;
    }
}
