package muyu.data.test.common.engine.scope;



import muyu.data.test.common.context.DataModelContextHolder;
import muyu.data.test.common.engine.Engine;
import muyu.data.test.common.model.DataModel;
import muyu.data.test.common.model.process.DataModelProcessModel;

/**
 * 数据模型引擎
 * @ClassName DataModelEngine
 * @Author: 森静若林
 * @Date: 2024/5/6 13:48
 */
public abstract class DataModelEngine implements Engine<DataModelProcessModel> {

    @Override
    public DataModelProcessModel get (){
        return DataModelContextHolder.get();
    }

    public DataModel getModel(){
        return get().getDataModel();
    }


    public String getKey () {
        return getModel().getKey();
    }

    public Object getValue () {
        return getModel().getVal();
    }

    public String getSourceType () {
        return getModel().getSourceType();
    }

    public String getProcessType () {
        return getModel().getProcessType();
    }

    public Class<?> getProcessClass () {
        return getModel().getProcessClass();
    }

}
