package muyu.data.test.common.engine.scope;

import muyu.data.test.common.context.DataSetContextHolder;
import muyu.data.test.common.engine.Engine;
import muyu.data.test.common.model.DataSetModel;
import muyu.data.test.common.model.RecordModel;
import muyu.data.test.common.model.process.DataSetProcessModel;

import java.util.List;

/**
 * 数据集引擎
 * @ClassName DataSetEngine
 * @Author: 森静若林
 * @Date: 2024/5/6 13:48
 */
public abstract class DataSetEngine implements Engine<DataSetProcessModel> {

    @Override
    public DataSetProcessModel get (){
        return DataSetContextHolder.get();
    }

    public DataSetModel getModel(){
        return get().getDataSetModel();
    }

    public List<RecordModel> getRecordModels () {
        return getModel().getRecordModels();
    }

}
