package com.data.test.common;

import com.data.test.server.TestService;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.controller.BaseController;
import lombok.extern.log4j.Log4j2;
import muyu.data.test.common.model.DataModel;
import muyu.data.test.common.model.DataModel;
import muyu.data.test.common.req.TestDataModelReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.sql.*;
import java.util.List;

@Log4j2
@RestController
@RequestMapping("/extract")
public class TestController extends BaseController {
    @Autowired
    private TestService service;
    /**
     * 随机字段
     * @param id
     * @return
     */
    @GetMapping("getRabdomData")
    public Result<List<DataModel>> getRabdomData(Long id, String tableName,Integer ruleLevel) throws SQLException {
        return success(service.getRabdomData(id,tableName,ruleLevel));
    }

    /**
     * 展示队列
     * @param id
     * @param tableName
     * @param ruleLevel
     * @return
     * @throws Exception
     */
    @GetMapping("getColumn")
    public Result<List<List<DataModel>>> getColumn(Long id, String tableName, Integer ruleLevel) throws Exception {
        return success(service.getColumn(id,tableName,ruleLevel));
    }

    @PostMapping("setColumn")
    public Result setColumn(@RequestBody TestDataModelReq testDataModelReq){
        return success(service.setColumn(testDataModelReq));
    }

    @PostMapping("editionInitialize")
    public void editionInitialize(){
        service.editionInitialize();
    }
}
