package com.data.test.mq;

import com.data.test.common.TestController;
import lombok.extern.log4j.Log4j2;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
@Log4j2
public class Consumer {
    @Autowired
    private TestController testController;
    //队列名称
    public static final String QueueName = "edition";
    /**
     * 监听队列
     */
    @RabbitListener(queuesToDeclare = {@Queue("edition")})
    public void testEdition(Integer id){
        if (id>0){
            testController.editionInitialize();
            log.info("初始化");
        }else{
            log.info("等待");
        }
    }
}
