package com.muyu.edition.context;


import com.muyu.edition.model.process.DataModelProcessModel;
import lombok.Data;
import lombok.experimental.SuperBuilder;

import java.sql.Connection;

/**
 * 数据模型上下文
 * @ClassName DataModelContextHolder
 * @Author 森静若林
 */
@Data
@SuperBuilder
public class DataModelContextHolder{

    private static final ThreadLocal<DataModelProcessModel> THREAD_LOCAL=new ThreadLocal<>();

    private RecordContextHolder recordContextHolder;

    public static DataModelContextHolder build(RecordContextHolder recordContextHolder){
        return DataModelContextHolder.builder()
                .recordContextHolder(recordContextHolder)
                .build();
    }

    public static DataModelProcessModel get() {
        return THREAD_LOCAL.get();
    }

    public static void set(DataModelProcessModel dataModelProcessModel) {
        THREAD_LOCAL.set(dataModelProcessModel);
    }

    public static void remove() {
        THREAD_LOCAL.remove();
    }
}
