package com.muyu.edition.domain;

import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.common.security.utils.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Date;

/**
 * 规则引擎版本对象 edition
 *
 * @author muyu
 * @date 2024-05-06
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class Edition extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    private Long id;

    /**
     * 规则序号
     */
    @Excel(name = "规则序号")
    private Long ruleId;

    /**
     * 版本类
     */
    @Excel(name = "版本类")
    private String versionClass;

    /**
     * 版本名称
     */
    @Excel(name = "版本名称")
    private String name;

    /**
     * 版本编码
     */
    @Excel(name = "版本编码")
    private String versionCode;

    /**
     * 版本状态
     */
    @Excel(name = "是否发布")
    private Integer editionStatus;
    /**
     * 引擎状态
     */
    @Excel(name = "是否激活")
    private String ruleStatus;

    @Excel(name = "是否测试")
    private Integer ruleIsTest;

    /**
     * 内容
     */
    @Excel(name = "内容描述")
    private String editionContent;

    @Excel(name = "版本内容")
    private String ruleContent;

    public static Edition updateEdition(Long id){
        return Edition.builder()
                .id(id)
                .editionStatus(0)
                .build();
    }
}
