package com.muyu.edition.engine.scope;


import com.muyu.edition.context.DataModelContextHolder;
import com.muyu.edition.engine.Engine;
import com.muyu.edition.model.DataModel;
import com.muyu.edition.model.process.DataModelProcessModel;

/**
 * 数据模型引擎
 * @ClassName DataModelEngine
 * @Author: 森静若林
 * @Date: 2024/5/6 13:48
 */
public abstract class DataModelEngine implements Engine<DataModelProcessModel> {

    @Override
    public DataModelProcessModel get (){
        return DataModelContextHolder.get();
    }

    public DataModel getModel(){
        return get().getDataModel();
    }


    public String getKey () {
        return getModel().getKey();
    }

    public Object getValue () {
        return getModel().getValue();
    }

    public String getSourceType () {
        return getModel().getSourceType();
    }

    public String getProcessType () {
        return getModel().getProcessType();
    }

    public Class<?> getProcessClass () {
        return getModel().getProcessClass();
    }

}
