package com.muyu.edition.engine.scope;


import com.muyu.edition.context.RecordContextHolder;
import com.muyu.edition.engine.Engine;
import com.muyu.edition.model.DataModel;
import com.muyu.edition.model.RecordModel;
import com.muyu.edition.model.process.RecordProcessModel;

import java.util.List;

/**
 * 记录引擎
 * @ClassName RecordEngine
 * @Author: 森静若林
 * @Date: 2024/5/6 13:48
 */
public abstract class RecordEngine implements Engine<RecordProcessModel> {

    @Override
    public RecordProcessModel get (){
        return RecordContextHolder.get();
    }

    public List<String> getKeys(){
        return get().getKeys();
    }

    public RecordModel getModel(){
        return get().getRecordModel();
    }

    public List<DataModel> getDataModels () {
        return getModel().getDataModels();
    }
}
