package com.muyu.goods.edition.remote;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.edition.domain.Edition;
import com.muyu.goods.edition.remote.factory.DataMangFacrory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;

import java.util.List;

/**
 * 远程调用
 */
@FeignClient(
        contextId = "editionSel",
        value = ServiceNameConstants.EDITION_MUYU,
        fallbackFactory = DataMangFacrory.class,
        path = "/edition"
)
public interface EditionDataRemoteService {
    @PostMapping("lists")
    public Result<List<Edition>> lists();
}
