package com.muyu.goods.edition.remote;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.edition.domain.RuleEngine;
import com.muyu.goods.edition.remote.factory.DataMangFacrory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;

import java.util.List;

/**
 * 远程调用
 */
@FeignClient(
        contextId = "engineSel",
        value = ServiceNameConstants.EDITION_MUYU,
        fallbackFactory = DataMangFacrory.class,
        path = "/engine"
)

public interface RemoteDataManagerService {
    @PostMapping("/lists")
    public Result<List<RuleEngine>> list();
}
