package com.muyu.system.remote;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.system.domain.DataAccess;
import com.muyu.system.remote.factory.DataMangSystemFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;

import java.util.List;

/**
 * 远程调用
 */
@FeignClient(
        contextId = "RemoteSys",
        value = ServiceNameConstants.System_MUYU,
        fallbackFactory = DataMangSystemFactory.class,
        path = "/access"
)
public interface RemoteSystemManageService {
    @PostMapping("/lists")
    public Result<List<DataAccess>> lists();
}
